#include <stdio.h>
#include <conio.h>
#include <math.h>
#include <stdlib.h>

void header(void)
{
int i;
struct text_info ti;
gettextinfo(&ti);
clrscr();
textcolor(9);
cprintf("");
for(i = 0; i < ti.screenwidth-2; i++)
cprintf("");
cprintf("\r");
cprintf("");
gotoxy(20, 2);
textcolor(12);
cprintf("Ivan Derevyanko, IUST-12, Lab#2. Spline #5, e^x");
textcolor(9);
gotoxy(ti.screenwidth, 2);
cprintf("\r");
cprintf("");
for(i = 0; i < ti.screenwidth-2; i++)
cprintf("");
cprintf("");
}

typedef struct koeficient
{
     float s0,s1,s2,s3;
} COEF;

float * CalcSystem(float * fullmat,int N)
{
  int i,j,k;
  float d,*res;

  for(i = 1;i<N;i++)
   for(j = 0; j < i; j++)
      {
	d = fullmat[i*(N+1)+j]/fullmat[(j)*(N+1) + j];
	for(k = 0;k < N+1; k++ )
	    fullmat[i*(N+1)+k] -=  fullmat[(j)*(N+1)+k] * d;
     }

   res = (float*)malloc(sizeof(float)*N);
   for(i = N-1;i>=0;i--)
   {
	d = 0;
	for(j = N-1;j>i;j--)
	      d +=fullmat[i*(N+1) + j]*res[j];
	res[i] = (fullmat[i*(N+1) + N] - d)/fullmat[i*(N+1)+i];
   }
   return res;

}

void drawtabhead()
{
    header();
    gotoxy(10, 10);
    textcolor(13);
    cprintf("Ŀ");
    gotoxy(10, 11);
    cprintf("      X            Y      ");
    gotoxy(10, 12);
    cprintf("Ĵ");
}
void drawtabbottom(int y)
{
    gotoxy(10, y);
    textcolor(13);
    cprintf("");
}

void input_data(int *n, float *h, float *x)
	{
	header();
	gotoxy(10, 10);
	textcolor(14);
	cprintf("Write amount of points:");
	scanf("%d",n);
	gotoxy(10, 11);
	cprintf("Write h:");
	scanf("%f",h);
	gotoxy(10, 12);
	cprintf("Write X[0]:");
	scanf("%f", x);
	}

void main()
{
   float * X,*Y,*d,h,*m1,*m2,*matrix,arg,f;
   int n,i,j,SW,SH;
   COEF * koef;
   do
   {
   X = (float*)malloc(sizeof(float)*n);
   Y = (float*)malloc(sizeof(float)*n);
   input_data(&n, &h, X);
   drawtabhead();
   for(i = 0;i<n;i++)
		{
		X[i] = X[0] + i*h;
		Y[i] = exp(X[i]);
		textcolor(13);
		gotoxy(10, 13+i);
		cprintf("%13.3f%13.3f\n",X[i],Y[i]);
		}
   drawtabbottom(12+n);
   m2 = (float*)malloc(sizeof(float)*n);

   d = (float*)malloc(sizeof(float)*(n-1));

   koef = (COEF*)malloc(sizeof(COEF)*(n-1));
   SH = n-2;
   SW = SH+1;
   matrix = (float*)calloc(SH*SW,sizeof(float));
   for(i = 0; i<n-1; i++)
   {
     d[i] = (Y[i+1] - Y[i])/h;
   }
   gotoxy(10, 20);
   textcolor(10);
   cprintf("Input m[0]: ");
   scanf("%f", &m2[0]);
   gotoxy(10, 21);
   cprintf("Input m[%d]:", n);
   scanf("%f", &m2[n-1]);

   //m2[0] = 0;
   //m2[n-1] = 0;

   matrix[0] = 4*h;
   matrix[1] = h;
   matrix[SW-1] = 6*(d[1] - d[0]);

   for(i = 1; i< SH-1; i++)
   {
     matrix[i*SW+i-1] = h;
     matrix[i*SW+i] = 4*h;
     matrix[i*SW+i+1] = h;
     matrix[i*SW+SW-1] = 6*(d[i] - d[i-1]);
   }
   matrix[i*SW+i] = h;
   matrix[i*SW+i+1] = 4*h;
   matrix[i*SW+SW-1] = 6*(d[i]-d[i-1]);
   m1  = CalcSystem(matrix,SH);
   for(i = 1;i<n-1;i++)
      m2[i] = m1[i-1];

   for(i = 0;i< n-1; i++)
   {
     koef[i].s0 = Y[i];
     koef[i].s1 = m2[i] / 2;
     koef[i].s2 = d[i] - h*(2*m2[i] + m2[i+1])/6;
     koef[i].s3 = (m2[i+1] - m2[i])/(6*h);
   }    header();
	textcolor(10);
   for(i=0;i<n-1;i++)
   {
      gotoxy(10, 10+i);
      cprintf("P[%d]: %9.3f %9.3f %9.3f %9.3f",i,koef[i].s3,koef[i].s2,koef[i].s2,koef[i].s0);
   }
	gotoxy(10, 20);
	textcolor(11);
      cprintf("Write X:");
    scanf("%f",&arg);
    i = (int)floor((arg-X[0])/h);

    f = koef[i].s3*pow(arg-X[i],3)+
     koef[i].s2*pow(arg-X[i],2)+
     koef[i].s1*pow(arg-X[i],1)+
     koef[i].s0;
     gotoxy(10, 22);
     textcolor(14);
     cprintf("\ne^%0.3f = %0.3f",arg,f);

   free(X);
   free(Y);
   free(m1);
   free(m2);
   free(d);
   free(matrix);
   free(koef);
   gotoxy(25, 40);
   textcolor(10);
   cprintf("FOR EXIT PRESS ESC");
   }while(getch() != 27);
   return;
}